Unit Except;

{-------- Try/Raise/Finally from LONGJUMP.PAS (SWAG) ---------}

(*-

 (c)1998, Paul TOTH <tothpaul@mygale.org>
 http://www.mygale.org/~tothpaul


 sample code :


 --------------------
  var
   e:TException;

  begin

   if Try(e) then begin { push "e" on "TryStack" }

    { do something, can use Raise('Error message'); }

    finally; { just remove "e" from "TryStack", no exception }

   end else begin

    writeln(e.message); { raise message, "e" was poped by a "raise" }

  end;

 ------------------
  var
   e1,e2:TException;

  begin

   if Try(e1) then begin { push "e1" on TryStack }

    if try(e2) then begin { push "e2" on TryStack }

     raise('e2 exception'); { <-- stop execution (pop e2) }

    end else begin

     raise(nil); { <-- raise e1 with e2 message (pop e1) }

    end;

    finally; { just remove "e1" from "TryStack" <-- never executed ! }

   end else begin

    writeln(e1.message); { raise message }

  end;
 ------------------

-*)

Interface

Type
 Exception=^TException;
 TException=record
  bp,ip,cs,sp:word;
  Message:PChar;
  Next:pointer;
 end;


{ TRY: store Except on TryStack, return TRUE }
function Try(Var Except:TException):boolean;
{ RAISE: restore TRY state (simulate a TRY),Remove exception, return FALSE }
Procedure raise(const AMessage:PChar);
{ FINALLY: remove last TRY }
procedure finally;

Implementation

Const
 TryStack:Exception=nil;
 Unknow:pchar='Unknow error';

function Try(Var Except:TException):boolean;
(*
 begin
 { do not use a "WITH Except DO" or Pascal will change SP !!! }
  Except.bp:=word(ptr(SSeg,SPtr+2)^);
  Except.ip:=word(ptr(SSeg,SPtr+4)^);
  Except.cs:=word(ptr(SSeg,SPtr+6)^);
  Except.sp:=SPtr;
  Except.Message:=Unknow;
  Except.Next:=TryStack;
  TryStack:=@Except;
  Try:=True;
 end;
*)
 assembler;
 asm
  LES DI,Except; MOV SI,DI
  MOV AX,[BP+0];           STOSW { BP }
  MOV AX,[BP+2];           STOSW { IP }
  MOV AX,[BP+4];           STOSW { CS }
  MOV AX,SP;               STOSW { SP }
  MOV AX,WORD(Unknow+0);   STOSW { Message }
  MOV AX,WORD(Unknow+2);   STOSW
  MOV AX,WORD(TRYSTACK+0); STOSW { Next    }
  MOV AX,WORD(TRYSTACK+2); STOSW
  MOV WORD(TRYSTACK+0),SI  { TryStack:=@Except }
  MOV WORD(TRYSTACK+2),ES
  MOV AL,True
 end;

Procedure raise(const AMessage:PChar);
(*
 var
  SP:word;
 begin
  if TryStack=nil then halt;
  TryStack^.Message:=AMessage;
  word(ptr(SSeg,TryStack^.SP+0)^):=TryStack^.BP;
  word(ptr(SSeg,TryStack^.SP+2)^):=TryStack^.IP;
  word(ptr(SSeg,TryStack^.SP+4)^):=TryStack^.CS;
  SP:=TryStack^.SP;
  TryStack:=TryStack^.Next;
  asm mov bp,&SP end;
  asm mov al,False end; { Try:=False }
 end;
*)
 begin
  if TryStack=nil then halt; { and how can I call Halt in INLINE ASM ??? }
  asm
   PUSH DS
    LDS SI,TRYSTACK
    MOV AX,WORD(AMESSAGE+2)
    OR  AX,AX
    JZ  @NoMessage
     MOV [SI+10],AX
     MOV AX,WORD(AMESSAGE)
     MOV [SI+8],AX
    @NoMessage:
    MOV DI,[SI+6]           {SP}
    LODSW; MOV SS:[DI+0],AX {BP}
    LODSW; MOV SS:[DI+2],AX {IP}
    LODSW; MOV SS:[DI+4],AX {CS}
    MOV AX,[SI+6] { Next }
    MOV DX,[SI+8]
   POP DS
   MOV WORD(TRYSTACK+0),AX
   MOV WORD(TRYSTACK+2),DX
  {$IFOPT G+} {  286 instructions use LEAVE = MOV SP,BP; POP BP }
   MOV BP,DI
  {$ELSE}     { 8086 instructions use only POP BP }
   MOV SP,DI
  {$ENDIF}
   MOV AL,False
  end;
 end;

procedure finally; assembler; { just remove current TryStack }
 asm
  MOV AX,WORD(TRYSTACK+2); { prevent nil pointer }
  OR  AX,AX
  JZ @done
   MOV ES,AX
   MOV DI,WORD(TRYSTACK)   { TryStack:=TryStack^.Next; }
   MOV AX,ES:[DI+12]
   MOV DX,ES:[DI+14]
   MOV WORD(TRYSTACK+0),AX
   MOV WORD(TRYSTACK+2),DX
  @done:
 end;

end.
